#include <bits/stdc++.h>

using namespace std;

int n;
int k;
//0-rastuci
//1-opadajuci
//2-neutralni
int l,r;
vector<int> ve;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cerr.tie(0);

    cin >> n >> k;

    for(int i=1;i<=n;i++)
    {
        int x;
        cin >> x;
        ve.push_back(x);
    }

    if(n==1)
    {
       cout << ve[0];
       return 0;
    }

    int left=k;
    int prev=-1;

    while(left>0)
    {
        vector<int> temp;

        for(int i=0;i+1<ve.size();i++)
        {
           if(ve[i]>ve[i+1])
           {
              left--;
              if(left==0)
              {
                  for(int j=i+1;j<ve.size();j++) temp.push_back(ve[j]);
                  for(int j=0;j<temp.size();j++) cout << temp[j] <<  " ";
              }
           }
           else temp.push_back(ve[i]);
        }

        if(temp.size()==prev)
        {
            for(int i=0;i<n-k;i++) cout << temp[i] << " ";
            return 0;
        }

        prev=temp.size();

        ve.clear();
        ve=temp;
    }


    return 0;
}